using System;
using NUnit.Framework;

namespace Smdn.Net.Imap4.Client {
  [TestFixture]
  public class ImapMessageNotFoundExceptionTests {
    [Test]
    public void TestSerializeBinary1()
    {
      var ex = new ImapMessageNotFoundException(ImapSequenceSet.CreateSet(1, 2, 3));

      Assert.IsNotNull(ex.SequenceOrUidSet);

      Smdn.Net.TestUtils.SerializeBinary(ex, delegate(ImapMessageNotFoundException deserialized) {
        Assert.IsNotNull(deserialized.SequenceOrUidSet);
        Assert.IsFalse(deserialized.SequenceOrUidSet.IsUidSet);
        Assert.AreEqual("1,2,3", deserialized.SequenceOrUidSet.ToString());
      });
    }

    [Test]
    public void TestSerializeBinary2()
    {
      var ex = new ImapMessageNotFoundException(ImapSequenceSet.CreateUidFromSet(1L));

      Assert.IsNotNull(ex.SequenceOrUidSet);

      Smdn.Net.TestUtils.SerializeBinary(ex, delegate(ImapMessageNotFoundException deserialized) {
        Assert.IsNotNull(deserialized.SequenceOrUidSet);
        Assert.IsTrue(deserialized.SequenceOrUidSet.IsUidSet);
        Assert.AreEqual("1:*", deserialized.SequenceOrUidSet.ToString());
      });
    }
  }
}

